
var LOGFILE_NAME = "sonos-controller.log";
var lWarn = {
		logln : function(o) {
		}
	};
	var lInfo = {
		logln : function(o) {
		}
	};


lInfo = new Logger(LOGFILE_NAME);
lWarn = new Logger(LOGFILE_NAME);

var lPerf = {
	logln : function(o) {
	}
};

lPerf = new Logger("sonos-controller-perf.log");

function getPlayerIPForZoneId(zoneID) {
	if (zoneID==null)
		return null;
	var oPlayerArray=Property.getNode('players').getChildren();
	for (var iIndex=0;iIndex<oPlayerArray.length;iIndex++) {
		if (oPlayerArray[iIndex].getChild('zoneID')!=null)
			if (oPlayerArray[iIndex].getChild('zoneID').getValue()==zoneID)
				if (oPlayerArray[iIndex].getChild('disabled').getValue()==false) {
					if (oPlayerArray[iIndex].getChild('coordinator').getValue())
						return oPlayerArray[iIndex].getChild('ip').getValue(); 
					else {
						var groupID=oPlayerArray[iIndex].getChild('group').getValue();
						for (var jIndex=0;jIndex<oPlayerArray.length;jIndex++) {
							if (oPlayerArray[jIndex].getChild('group')==groupID)
								if (oPlayerArray[jIndex].getChild('coordinator').getValue())
									return oPlayerArray[jIndex].getChild('ip').getValue();
						}
					}
				}
	}
	return null;
}

function isPlayerForZoneDisabled(zoneID) {
	if (zoneID==null)
		return true;
	var oPlayerArray=Property.getNode('players').getChildren();
	for (var iIndex=0;iIndex<oPlayerArray.length;iIndex++) {
		if (oPlayerArray[iIndex].getChild('zoneID')!=null)
			if (oPlayerArray[iIndex].getChild('zoneID').getValue()==zoneID)
				if (oPlayerArray[iIndex].getChild('disabled').getValue()==false)
					return false
	}
	return true;
}

function signalDisabledPlayer(ip) {
	lWarn.logln('Player with ip ' + ip + ' is not reachable');
	var oPlayerArray=Property.getNode('players').getChildren();
	for (var jIndex=0;jIndex<oPlayerArray.length;jIndex++) {
		if (oPlayerArray[jIndex].getChild('ip')!=null)
			if (oPlayerArray[jIndex].getChild('ip').getValue()==ip) {
				oPlayerArray[jIndex].getChild('online').setValue(false);
				new Event('sonos.player',{actions:'searchAfterLostPlayer',time:'+30'}).raise();
			} 
	}
}

function isIPOnline(ip) {
	var oPlayerArray=Property.getNode('players').getChildren();
	for (var jIndex=0;jIndex<oPlayerArray.length;jIndex++) {
		if (oPlayerArray[jIndex].getChild('ip')!=null)
			if (oPlayerArray[jIndex].getChild('ip').getValue()==ip)
				if (oPlayerArray[jIndex].getChild('online')!=null) 
					if (oPlayerArray[jIndex].getChild('online').getValue()==true)
						return true;
	}
	return false;
}

function isIPOnlineAndCoordinator(ip) {
	var oPlayerArray=Property.getNode('players').getChildren();
	for (var jIndex=0;jIndex<oPlayerArray.length;jIndex++) {
		if (oPlayerArray[jIndex].getChild('ip')!=null)
			if (oPlayerArray[jIndex].getChild('ip').getValue()==ip)
				if (oPlayerArray[jIndex].getChild('online')!=null) 
					if (oPlayerArray[jIndex].getChild('online').getValue()==true)
						if (oPlayerArray[jIndex].getChild('coordinator')!=null) 
							if (oPlayerArray[jIndex].getChild('coordinator').getValue()==true)
								return true;
	}
	return false;
}

var SOAPBodyStart =
	'<?xml version="1.0" encoding="utf-8"?>' + 
	'<s:Envelope s:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:s="http://schemas.xmlsoap.org/soap/envelope/">' +
		'<s:Body>';
var SOAPBodyEnd =
	    '</s:Body>' + 
     '</s:Envelope>';

function upnpSetRelativeVolume(szIpAddressRenderer,nVolume) {
	try {
		if (!isIPOnlineAndCoordinator(szIpAddressRenderer))
			return;
		var oStartDate=new Date().getTime();
		var http_headers = [];
		http_headers['extra_hrd1'] = 'Content-Type: text/xml; charset="utf-8"';
		http_headers['extra_hdr2'] = 'SOAPACTION: "urn:schemas-upnp-org:service:GroupRenderingControl:1#SetRelativeGroupVolume"';

		var h = new HTTP({ 'debug' : 0, 'connectTimeout' : 200}, http_headers);
		h.reset();

		var url = 'http://' + szIpAddressRenderer + ':1400/MediaRenderer/GroupRenderingControl/Control';
		var action = '<u:SetRelativeGroupVolume xmlns:u="urn:schemas-upnp-org:service:GroupRenderingControl:1">' + 
						'<Adjustment>' + nVolume + '</Adjustment>' +
		                '<InstanceID>0</InstanceID>' + 
		             '</u:SetRelativeGroupVolume';
		var result=h.post(url, '', SOAPBodyStart + action + SOAPBodyEnd);
		if (result==null)
			signalDisabledPlayer(szIpAddressRenderer);

		lPerf.logln('runtime upnpSetRelativeVolume '+ szIpAddressRenderer + ' : ' + (new Date().getTime()-oStartDate) + 'ms');
	} catch (e) {
		lInfo.logln("Error executing upnpStop command " + e);
	}
}

function volUp() {
	lInfo.logln('volup');
	var sIP=getPlayerIPForZoneId(raisedEvent.parameter.zoneID);
	upnpSetRelativeVolume(sIP,3);
}

function volDown() {
	lInfo.logln('voldown');
	var sIP=getPlayerIPForZoneId(raisedEvent.parameter.zoneID);
	upnpSetRelativeVolume(sIP,-3);
}

if (raisedEvent.name=='sonos.volume') {
	if (raisedEvent.parameter.sceneID==12)
		volUp();
	else
		volDown();
}